<?php
/*
Wacintaki Poteto Avatar Editor Copyright 2004-2007 Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 1.3.8 - Last modified 7/6/2007
*/


// Load bootstrap
define ('BOOT', 1);
require ('boot.php');

// Config:
$max_width  = $cfg['avatar_x'];
$max_height = $cfg['avatar_y'];
$good_upload = FALSE;


if ($cfg['use_avatars'] != 'yes') {
	report_err($langop_avatardisable);
}
if (!isset ($user['avatar'])) {
	report_err($langop_err_favatar, TRUE);
}
if (!$flags['member']) {
	report_err($langop_loginerr);
}


// Upload avatar
if ($_POST['action'] == 'do') {
	require ('paintsave.php');

	$old_filename = $user['avatar'];
	$old_filepath = $cfg['avatar_folder'].'/'.$user['avatar'];

	if ($_POST['del']) {
		// Delete Avatar?
		if (!empty ($user['avatar']) && file_exists ($old_filepath)) {
			@unlink ($old_filepath);
		}

		$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET avatar='' WHERE usrname='$OekakiU'");

		$user['avatar'] = '';
	} elseif (!empty ($_FILES['avatar']['tmp_name'])) {
		// If file OK, get it
		if ($_FILES['avatar']['error'] != 0 || empty ($_FILES['avatar']['tmp_name'])) {
			report_err($langop_err_fileupl, TRUE);
		}

		// Get file
		$buffer = file_get_contents ($_FILES['avatar']['tmp_name']);

		// Filetype
		$type = get_filetype($buffer);
		if ($type != 'png' && $type != 'jpg' && $type != 'gif') {
			report_err($langop_unsuppic, TRUE);
		}

		// Get filesize
		$max_size = $cfg['avatar_x'] * $cfg['avatar_y'] * 3;
		if (strlen ($buffer) > $max_size) {
			report_err(str_replace ('{s}', $max_size, $langop_filetoolar), TRUE);
		}

		// Image properties
		$imagesize = @getimagesize ($_FILES['avatar']['tmp_name']);
		if (!$imagesize) {
			report_err($langop_err_imagesize, TRUE);
		}
		if ($imagesize[0] > $max_width | $imagesize[1] > $max_height) {
			report_err($langop_err_imagelar." {$max_width} &times {$max_height} ".$langop_word_pixels."!", TRUE);
		}

		// Set filename
		// For browser caching reasons, set a pseudo-random name
		$filename = md5 ($OekakiU + strval (rand ())).'.'.$type;
		$filepath = $cfg['avatar_folder'].'/'.$filename;

		// Remove old avatar (WinPHP cache safe)
		if ($old_filename != $filename) {
			@unlink ($old_filepath);
		}

		// Save new one
		file_unlock ($filepath);
		if ($fp = fopen ($filepath, 'wb')) {
			fwrite ($fp, $buffer, strlen ($buffer));
			fclose ($fp);

			// Add to DB
			$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET avatar='$filename' WHERE usrname='$OekakiU'");

			$good_upload = TRUE;
		} else {
			report_err($langop_fileuprop, TRUE);
		}

		$user['avatar'] = $filename;
	}
}


/* START HTML */
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<title><?=$cfg['op_title']?></title>
	<meta http-equiv="content-type" content="text/html; charset=<?=$charset?>">
	<meta http-equiv="content-language" content="<?=$metatag_language?>">

	<link rel="stylesheet" type="text/css" href="<?=$cssinclude?>" title="<?=$template_name?>">
</head>

<body>


<div class="pheader">
	<?=$langop_avatarupl?>
</div>
<div class="pinfotable">
	<p style="text-align: center;">
<? if ($good_upload) { ?>
		<?=$langop_avatarupdate?>
<? } else { ?>
		<?=$langop_avatarform?><br />
		<?=$langop_notlarg?> <?=$max_width ?>&times;<?=$max_height ?> <?=$langop_word_pixels?>.<br />
<? if ($cfg['use_c_avatars'] != 'yes') { ?>
		<?=$langop_avatarshpi?>
<? } ?>
<? } ?>
	</p>
</div>
<br />

<div>
	<table class="pinfotable" style="width: 100%;">
	<tr>
	<td class="pinfoask" style="width: 40%;" valign="top">
		<?=$langop_word_avatars?>:
	</td>
	<td class="pinfoenter" valign="top">
<? if (!empty ($user['avatar'])) { ?>
		<img src="<?= $cfg['avatar_folder'].'/'.$user['avatar'];?>" border="0" alt="" /><br />
<? } else {?>
		(<?=$langop_noavatar?>)
<? } ?>
	</td>
	</tr>

	<tr><td colspan="2">&nbsp;</td></tr>

	<tr>
	<td class="pinfoask" style="width: 40%;" valign="top">
		<?=$langop_chgavatar?>:
	</td>
	<td class="pinfoenter" valign="top">
		<form name="form1" method="post" action="<?=$_SERVER['PHP_SELF'];?>" enctype="multipart/form-data">
			<input name="action" type="hidden" value="do" />
			<input name="avatar" type="file" size="30" class="txtinput" /><br />
			<br />
<? if (!empty ($user['avatar'])) { ?>
			<input name="del" type="checkbox" /> <?=$langop_delavatar?><br />
			<br />
<? } ?>
			<input name="submit" type="submit" value="<?=$langop_word_submit?>" class="submit" />
		</form>
	</td>
	</tr>
	</table>
</div>

<p style="text-align: center;">
	<a onclick="javascript: window.close();" href="#"><?=$langop_common_window?></a>
</p>

</body>
</html>
<?

mysql_close ($dbconn);
exit;
?>