<?php
/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wacintaki Poteto modifications Copyright 2004-2007 Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 1.3.8 - Last modified 7/29/2007
*/


// Load bootstrap
define ('BOOT', 1);
require ('boot.php');


// Input
$recno = w_gpc('recno', 'i+');

// SQL
$result = mysql_query ("SELECT * FROM {$OekakiPoteto_Prefix}oekakidta WHERE ID_2={$recno}");
if (!$result) {
	report_err('Unable to read picture #'.$recno);
}
$row = mysql_fetch_array ($result);

if ($row['animation'] != 1) {
	report_err('No Animation', TRUE);
}


// Set file info
$file_name = "{$cfg['op_pre']}{$row['PIC_ID']}.";
if ($row['datatype'] == 1) {
	$file_name .= 'oeb';
} else {
	$file_name .= 'pch';
}
$file_path = "{$cfg['op_pics']}/{$file_name}";

$file_size = filesize ($file_path);
$file_size = round (($file_size / 1024), 2);



?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<title><?=$cfg['op_title']?></title>
	<meta http-equiv="content-type" content="text/html; charset=<?=$charset?>">
	<meta http-equiv="content-language" content="<?=$metatag_language?>">

	<link rel="stylesheet" type="text/css" href="<?=$cssinclude?>" title="<?=$template_name?>">

	<script language="JavaScript" type="text/javascript" src="Poteto.js">
	</script>
</head>

<body>


<!-- View Info -->
<div class="pheader">
	[<strong><?= $row['PIC_ID']; ?></strong>]
	<strong><?=$langop_word_artist?>:</strong> <a onclick="openWindow('profile.php?user=<?=urlencode($row['usrname']);?>', 400, 500); return false" href="profile.php?user=<?=urlencode($row['usrname']);?>"><?=$row['usrname'];?></a>
	| <strong><?=$langop_install_title2?>:</strong> <?=$row['title'];?> 
<?php

// Time
if ($row['edittime'] > 10 ) {
	$edit_s = ceil ($row['edittime'] % 60);
	$edit_m = ceil ($row['edittime'] / 60 % 60);
	$edit_h = ceil ($row['edittime'] / 3600 % 60);

	if ($edit_h)
		$edit_s = 0;

	$edit_out = '';
	if ($edit_h)
		$edit_out .= "{$edit_h}h ";
	if ($edit_m)
		$edit_out .= "{$edit_m}m ";
	if ($edit_s)
		$edit_out .= "{$edit_s}s ";
} else {
	$edit_out = $langop_word_unknown;
}
echo "		| <strong>{$langop_word_time}:</strong> {$edit_out}\n";

?>
</div>

<div class="pinfotable" style="text-align: center;">
	<hr />

<?php
	// Applet code

	// Works for PCH Viewer and OekakiBBS
	$app_x = $row['px'];
	if ($row['px'] < 100)
		$app_x += (100 - $row['px']);

	// Which applet?
	switch ($row['datatype']) {
		case 0:
?>
	<applet name="pch" code="pch.PCHViewer.class" archive="shipainter/PCHViewer.jar" width="<?=$app_x;?>" height="<?=$row['py'] + 25;?>">
		<param name="speed" value="2" />
		<param name="image_width" value="<?=$row['px'];?>" />
		<param name="image_height" value="<?=$row['py'];?>" />
		<param name="pch_file" value="<?=$file_path;?>" />
		<param name="run" value="true" />
		<param name="buffer_progress" value="true" />
		<param name="buffer_canvas" value="true" />
	</applet>
<?
		break;

		case 1:
		// OekakiBBS requires "picw" to match applet width!
		// "pich" must be actual picture height.
?>
	<applet name="oeb" code="a.p.class" archive="oekakibbs.jar" width="<?=$app_x;?>" height="<?=$row['py'] + 38;?>" border="0">
		<param name="popup" value="0" />
		<param name="anime" value="2" />
		<param name="readanm" value="<?=$file_path;?>" />
		<param name="readanmpath" value="./" />
		<param name="picw" value="<?=$app_x;?>" />
		<param name="pich" value="<?=$row['py'];?>" />
		<param name="baseC" value="9999FF" />
		<param name="brightC" value="C0C0FF" />
		<param name="darkC" value="6666FF" />
		<param name="backC" value="CCCCFF" />
		<param name="buffer_canvas" value="true" />
	</applet>
<?
		break;

		case 2:
		case 3:
?>
	<applet name="pch" codebase="./shipainter" code="pch2.PCHViewer.class" archive="PCHViewer.jar" width="<?=$app_x;?>" height="<?=$row['py'] + 25;?>">
		<param name="speed" value="2" />
		<param name="image_width" value="<?=$row['px'];?>" />
		<param name="image_height" value="<?=$row['py'];?>" />
		<param name="pch_file" value="../<?=$file_path;?>" />

		<param name="res.zip" value="res.zip" />
		<param name="tt.zip" value="tt.zip" />

		<param name="run" value="true" />
		<param name="buffer_progress" value="flase" />
		<param name="buffer_canvas" value="false" />

		<param name="layer_count" value="5" />
		<param name="layer_max" value="8" />
		<param name="layer_last" value="2" />
		<param name="quality" value="1" />
	</applet>
<?
		break;
	}
?>
	<br />

	<?=$langop_viewani_files.': '.$file_size.'KB';?> 
</div>

<p style="text-align: center;">
	<?=$langop_word_download?>: <a href="<?=$file_path?>"><?=$file_name?></a>
</p>

<p style="text-align: center;">
	<a onclick="javascript: window.close();" href="#"><?=$langop_common_window?></a>
</p>

</body>
</html>
<? @mysql_close ($dbconn); ?>